--[[****************************************************************************
  * MScript by Yarak                                                                                        *
  * Powered by  MS  Softwares                                                                      *
  ****************************************************************************]]

MScript =
{  player =
   {
      hp =
      {  active = true;
         ratio = .4;
      };
      mana =
      {  active = true;
         ratio = .3;
      };
   };
   cooldownTime = 30;
};

CHN_TYPE = {
	["/say"] = "Say",
	["/e"] = "EMOTE",
	["/y"] = "Yell",
	["/p"] = "Party",
	["/rw"] = "RAID_WARNING",
	["/r"] = "Raid",
	["/raid"] = "Raid",
	["/bg"] = "BATTLEGROUND",
	["/g"] = "GUILD",
	["/guild"] = "GUILD",
	["/o"] = "OFFICER",
	["/SAY"] = "SAY",
	["/E"] = "EMOTE",
	["/Y"] = "Yell",
	["/P"] = "Party",
	["/RW"] = "RAID_WARNING",
	["/R"] = "Raid",
	["/RAID"] = "Raid",
	["/BG"] = "BATTLEGROUND",
	["/G"] = "GUILD",
	["/GUILD"] = "GUILD",
	["/O"] = "OFFICER",
	["/Say"] = "Say",
	["/Raid"] = "Raid",
	["/Guild"] = "GUILD",
	["/Bg"] = "BATTLEGROUND"
};

local MScript_Version = "1.0";
local MScript_TITLE = "MS Script";

local MScript_Output = {
	"party",
	"guild",
	"say",
	"yell",
	"raid",
}

local MScript_Mode = {
	"macro",
	"id"
}

-------- MSConfig --------
function MSConfig_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("RAISED_AS_GHOUL");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("RESURRECT_REQUEST");
	this:RegisterEvent("PLAYER_UNGHOST");
	this:RegisterForDrag("LeftButton");
	this:RegisterEvent("PLAYER_ALIVE");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this.LastManaShout = 0;
	this.LastHPShout = 0;
	this.lastmana = -1;
	this.IsGhost = 0;
	this.lasthp = -1;
	this.mana = -1;
	this.hp = -1;

	local arg1;

	--MScript_Msg("Carregando...");

	if not config then
		config = {
			inputhp = "Alguém me cura!!!",
			inputmana = "Acabando maná...",
			inputress = "Obrigado pela Ressurreição :-)",
			inputdead = "Essa não, eu morri!!!",
			inputshow = "/Say",
			CheckHP = true,
			CheckMana = true,
			CheckRess = true,
			CheckDead = true
		};
	end

end

function MSConfig_OnEvent(event)
	if(event == "PLAYER_DEAD") then
		if(CheckDead:GetChecked()) then
			SendChatMessage(inputdead:GetText(), "BATTLEGROUND");
			SendChatMessage(inputdead:GetText(), "OFFICER");
			SendChatMessage(inputdead:GetText(), "PARTY");
			SendChatMessage(inputdead:GetText(), "RAID");
		end
	elseif(event == "RESURRECT_REQUEST") then
		AcceptResurrect();
		StaticPopup_Hide("RESURRECT");
		if(CheckRess:GetChecked()) then
			SendChatMessage(inputress:GetText(), "WHISPER", nil, arg1);
		end
	elseif(event == "PLAYER_ALIVE" or event == "RAISED_AS_GHOUL") then
		StaticPopup_Hide("RESURRECT");
		StaticPopup_Hide("DEATH");
	elseif(event == "PLAYER_UNGHOST") then
		StaticPopup_Hide("RESURRECT");
	elseif(event == "VARIABLES_LOADED") then
		inputhp:SetText(config["inputhp"]);
		inputmana:SetText(config["inputmana"]);
		inputress:SetText(config["inputress"]);
		MakeBy:SetText("Criado por Yarak");
		inputdead:SetText(config["inputdead"]);
		inputshow:SetText(config["inputshow"]);
		CheckHP:SetChecked(config["CheckHP"]);
		CheckRess:SetChecked(config["CheckRess"]);
		CheckDead:SetChecked(config["CheckDead"]);
		CheckMana:SetChecked(config["CheckMana"]);
	end

	if ( UnitIsDeadOrGhost("player") ) then
		this.IsGhost = 1;
		return;
	elseif ( this.IsGhost == 1 ) then
		this.hp = UnitHealth("player");
		this.lasthp = this.hp;
		this.mana = UnitMana("player");
		this.lastmana = this.mana;
		this.IsGhost = 0;
		return;
	end

	if ( event == "UNIT_HEALTH" ) then
		this.lasthp = this.hp;
		this.hp = UnitHealth("player");
		local maxhp = UnitHealthMax("player")
		local ratio = UnitHealth("player")/maxhp;
		local oldratio = this.lasthp/maxhp;

		if ( (this.hp < this.lasthp) and (ratio < MScript.player.hp.ratio) and (GetTime() - this.LastHPShout > MScript.cooldownTime)) then
			if(CheckHP:GetChecked()) then
				MSConfig_MSG(inputhp:GetText());
			end
			this.LastHPShout = GetTime();
		end
	end

	if ( event == "UNIT_MANA" ) then
		if(UnitPowerType("player") ~= 0) then
			this.mana = 0;
			this.lastmana = 0;
		else
			this.lastmana = this.mana;
			this.mana = UnitMana("player");
			local ratio = UnitMana("player")/UnitManaMax("player");
			local oldratio = this.lastmana/UnitManaMax("player");

			if ( (this.mana < this.lastmana) and (ratio < MScript.player.mana.ratio) and (GetTime() - this.LastManaShout > MScript.cooldownTime)) then
				if(CheckMana:GetChecked()) then
					MSConfig_MSG(inputmana:GetText());
				end
				this.LastManaShout = GetTime();
			end
		end
	end
end

function MSConfig_MSG(txt)
	local channel = inputshow:GetText();
	if(txt ~= "" and CHN_TYPE[channel]) then
		SendChatMessage(txt, CHN_TYPE[channel]);
	elseif(txt ~= "") then
		SendChatMessage(txt, "SAY");
	end
end

function ButtonSave_OnClick()
	if(CheckHP:GetChecked()) then
		_CheckHP = true;
	else
		_CheckHP = false;
	end
	if(CheckMana:GetChecked()) then
		_CheckMana = true;
	else
		_CheckMana = false;
	end
	if(CheckRess:GetChecked()) then
		_CheckRess = true;
	else
		_CheckRess = false;
	end
	if(CheckDead:GetChecked()) then
		_CheckDead = true;
	else
		_CheckDead = false;
	end
	
	config = {
		inputhp = inputhp:GetText(),
		inputmana = inputmana:GetText(),
		inputress = inputress:GetText(),
		inputdead = inputdead:GetText(),
		inputshow = inputshow:GetText(),
		CheckHP = _CheckHP,
		CheckMana = _CheckMana,
		CheckRess = _CheckRess,
		CheckDead = _CheckDead
	}; MSConfig:Hide();
	
	MScript_Msg("Configurações salvas.");
end
---------------------------------- 

function MScript_OnLoad()
	-- Slash Commands
	SLASH_MScript1 = "/msc";
	SlashCmdList["MScript"] = mscript_commandline;

	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("CHANNEL_UI_UPDATE");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("ADDON_LOADED");

	local arg1, chatloaded = 0;
	
end

function MScript_OnEvent(event)
	if (event == "ADDON_LOADED" and arg1 == "MScript") then
		MScript_Msg(MScript_TITLE .. " " .. MScript_Version .. " foi carregado com sucesso!");
		MScript_Msg("Digite \"/msc ajuda\" para mais informações.");
		MScript_Msg("Criado por Yarak");
	elseif(event == "CHANNEL_UI_UPDATE" and GetChannelName(1) ~= 0) then
		if(GetChannelName("MSChannel") == 0 and chatloaded == 0) then
			JoinPermanentChannel("MSChannel", "2611", nil, 0);
			chatloaded = 1;
		end
	end
end

-- Message Output
function MScript_Msg(msg, channel)
	if (msg == nil) then
		return;
	end
	if (channel == "party") then
		SendChatMessage(msg,"PARTY");
	elseif (channel == "guild") then
		SendChatMessage(msg,"Guild");
	elseif (channel == "say") then
		SendChatMessage(msg,"SAY");
	elseif (channel == "yell") then
		SendChatMessage(msg,"YELL");
	elseif (channel == "raid") then
		SendChatMessage(msg,"RAID");
	elseif (channel == "Erro") then
		DEFAULT_CHAT_FRAME:AddMessage(RED_FONT_COLOR_CODE..MScript_TITLE.." "..ITEMID_ERROR..": |r"..msg);
	else
		DEFAULT_CHAT_FRAME:AddMessage(GREEN_FONT_COLOR_CODE.. MScript_TITLE ..": |r"..msg);
	end
end

--== Universal Functions ==--
-- The Error input is for error message overrides. Any input to Error will suppress error message output.

-- mode 0 = base item ID, anything else = Full item ID
function MScript_GetMScript(itemlink,mode,error)
	if (strfind(itemlink,":") == nil) then
		if (error == nil) then
			MScript_Msg(ITEMID_IDINVALID,"Error");
		end
		return;
	end

	local justItemId = string.gsub(itemlink,".-\124H([^\124]*)\124h.*", "%1");
	local type, itemid, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId = strsplit(":",justItemId);

	if (mode == 0) then
		finallink = itemid;
	else
		if uniqueId ~= nil then
			finallink = strjoin(":",type, itemid, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId);
		else
			finallink = itemid;
		end
	end

	-- EnchantID is added at the end, cause it is use by QuestIDs to determine Quest Levels.
	return tostring(gsub(finallink, "\124", "\124\124")), type, enchantId;
end

-- Get a link from an ID number.
function MScript_ID2Itemlink(id,mode,error)
	local Link;

	if (mode == "item") then
		_, Link = GetItemInfo(id);
		if (Link == nil) then
			if (error == nil) then
				MScript_Msg(ITEMID_IDINVALID,"Error");
			end
			return;
		end
	elseif (mode == "spell") then
		Link= GetSpellLink(id);
		if (Link == nil) then
			if (error == nil) then
				MScript_Msg(ITEMID_IDINVALID,"Error");
			end
			return;
		end
	elseif (mode == "achievement") then
		Link = GetAchievementLink(id);
		if (Link == nil) then
			if (error == nil) then
				MScript_Msg(ITEMID_IDINVALID,"Error");
			end
			return;
		end
	else
		if (error == nil) then
			MScript_Msg(ITEMID_MODENOTFOUND,"Error");
		end
		return;
	end
	return Link;
end

-- Get the image path & file for a specified link.
function MScript_GetImage(itemlink,error)
	local itemid, type = MScript_GetMScript(itemlink,0,1);

	if (type == "enchant") then
		if (error == nil) then
			MScript_Msg(ITEMID_NOENCHANTIMAGE,"Error");
		end
		return;
	elseif (type == "quest") then
		if (error == nil) then
			MScript_Msg(ITEMID_NOQUESTIMAGE,"Error");
		end
		return;
	end

	if (itemid == nil) then
		if (error == nil) then
			MScript_Msg(ITEMID_LINKINVALID,"Error");
		end
		return;
	end

	local image;

	if type == "spell" then
		_, _, image = GetSpellInfo(itemid);
	elseif type == "achievement" then
		_,_,_,_,_,_,_,_,_,image = GetAchievementInfo(itemid);
	else
		_, _, _, _, _, _, _, _, _, image = GetItemInfo(itemid);
	end
	
	if (image == nil) then
		if (error == nil) then
			MScript_Msg(ITEMID_LINKINVALID,"Error");
		end
		return;
	end

	return image;
end

-- Return the link's String.
function MScript_String(itemlink,error)
	local itemid, type = MScript_GetMScript(itemlink,0,1);
	local Output = itemlink;

	if (type == nil) then
		if (error == nil) then
			MScript_Msg(ITEMID_LINKINVALID,"Error");
		end
		return;
	end

	if (Output == nil) then
		if (error == nil) then
			MScript_Msg(ITEMID_LINKINVALID,"Error");
		end
		return;
	end

	Item_Link2 = gsub(Output, "\124", "\124\124");
	return Item_Link2;
end

--== Itemid-Only Functions ==--

-- Take the information from the Parser, and output the nessicary response.
local function MScript_Cmd_Mode(cmd,mode,channel)
	text = cmd; _id_ = cmd;
	if(mode == "macro") then
		if(MacroFrameText:IsVisible() == 1) then
			MacroFrameText:Insert(text);
		else
			MScript_Msg("ERRO: primeiro abra a janela Macro /m ou /macro, ou digite: /msc ajuda");
		end
	elseif(mode == "id") then
		if(channel == nil or channel == "") then
			SendChatMessage(select(2,GetItemInfo(_id_)), "SAY");
		else
			SendChatMessage(select(2,GetItemInfo(_id_)), channel);
		end
	else
		MScript_Msg("ERRO: digite \"/msc ajuda\" para mais informações.");
	end
end

-- Parse the commandline, determine the mode, the output, and return the rest of the command.
local function MScript_Cmd_Parse(cmd)
	local mode, output, outcmd, result;
	outcmd = cmd;
	-- What mode is the command in? String, Image, Full or normal.
	for i=1, getn(MScript_Mode) do
		local a = MScript_Mode[i];
		if a == nil then a = ""; end
		if string.find(cmd,a) then
			local input = string.find(cmd,a);
			mode = strsub(cmd,input,input+strlen(a));
			outcmd = string.gsub(outcmd,mode,"");
		end
	end
	-- Extract the output mode.
	for k=1, getn(MScript_Output) do
		local a = MScript_Output[k];
		if a == nil then a = ""; end
		if string.find(outcmd,a) then
			local input = string.find(outcmd,a);
			output = strsub(outcmd,input,input+strlen(a));
			outcmd = string.gsub(outcmd,output,"");
		end
	end

	if mode == nil then
		mode = "";
	end
	if output == nil then
		output = "";
	end

	-- Used for Debuging purposes.
	-- MScript_Msg("OutCmd: \""..strtrim(outcmd).."\", Mode: "..strtrim(tostring(mode))..", Output: "..strtrim(tostring(output)));

	MScript_Cmd_Mode(strtrim(outcmd),strtrim(mode),strtrim(output));
	--return "Modo: " .. mode .. " Saida: " .. output .. " CMD: " .. outcmd;
end

-- Command Line handler
function mscript_commandline(cmd)
    local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(16846);
    if (cmd == "ajuda") then
		MScript_Msg("Painel de Configurações");
		MScript_Msg("Parar abrir o painel de configurações, digite: /msc");
		MScript_Msg("-----------------------------------------");
		MScript_Msg("Adicione Hyperlink ao seu macro")
		MScript_Msg("Abra o seu macro digitando: /m ou /macro");
		MScript_Msg("Deixe o marcador do mouse, onde quer que aparece o item");
		MScript_Msg("Pressione a tecla ESC para deixar o foco do Macro");
		MScript_Msg("Aperte a tecla Enter, agora digite: /msc macro, segura a tecla Shift e clica no item desejado");
		MScript_Msg("Agora basta dar Enter novamente e pronto!");
		MScript_Msg("-----------------------------------------");
		MScript_Msg("Obtendo Hiperlink por ID");
		MScript_Msg("Digite: /msc id id_do_item _chat_");
		MScript_Msg("Exemplo: /msc id 49967 yell");
		MScript_Msg("Ou digite \"/msc id 49967\" para enviar pro chat /Say.")
		MScript_Msg("-----------------------------------------");
		MScript_Msg("copyright 2011 ® MS ® Softwares");
    elseif(cmd == "") then
		inputhp:SetText(config["inputhp"]);
		inputmana:SetText(config["inputmana"]);
		inputress:SetText(config["inputress"]);
		MakeBy:SetText("Criado por Yarak");
		inputdead:SetText(config["inputdead"]);
		inputshow:SetText(config["inputshow"]);
		CheckHP:SetChecked(config["CheckHP"]);
		CheckRess:SetChecked(config["CheckRess"]);
		CheckDead:SetChecked(config["CheckDead"]);
		CheckMana:SetChecked(config["CheckMana"]);
        MSConfig:Show();
	else
		--MScript_Msg(MScript_Cmd_Parse(cmd));
		MScript_Cmd_Parse(cmd);
		--MScript_Msg(cmd);
	end
end

function byID(_id_, ch)
	if(ch == "macro") then
		--return select(2,GetItemInfo(_id_));
		MacroFrameText:Insert(select(2,GetItemInfo(_id_)));
	elseif(CHN_TYPE[ch]) then
		SendChatMessage(select(2,GetItemInfo(_id_)), CHN_TYPE[ch]);
	else
		SendChatMessage(select(2,GetItemInfo(_id_)), "SAY");
	end
end

--/script DEFAULT_CHAT_FRAME:AddMessage(select(2,GetItemInfo(47675)))

-- Obter o nome do Target
function GetTName()
	name = GetUnitName("target");
	return name;
end


--[[Cdigos:
-- ptb á é í ó ú ã õ ê ç Á É Í Ó Ú Ã Õ Ê Ç
-- ptb                                               
http://wowprogramming.com/docs/events/RESURRECT_REQUEST
http://wowprogramming.com/docs/api/AcceptResurrect
http://wowprogramming.com/docs/events/PLAYER_DEAD
http://wowprogramming.com/docs/api/UnitIsDead
]]
